Global Const GFSR_GDIResources% = 1
Global Const GFSR_UserResources% = 2

Declare Function GetFreeSystemResources Lib "User" (ByVal fuSysResource As Integer) As Integer
Declare Function GetFreeSpace Lib "Kernel" (ByVal wFlags As Integer) As Long
Declare Function SndPlaySound Lib "MMSYSTEM.DLL" (ByVal lpszSoundName$, ByVal wFlags%) As Integer
   
' Flags used by SndPlaySound:
Const SND_ASYNC = &H1

Sub CenterForm (F As Form)
    'centers the passed non-mdi form on the desktop
    F.Move ((Screen.Width \ 2) - (F.Width \ 2)), ((Screen.Height \ 2) - (F.Height \ 2))
End Sub

Sub Draw3DBorder (TargetControl As Control, RaisedBorder%, BorderWidth%)
    ' Define how far the 3D lines are drawn from the
    ' outer edges of the control. Modify to your tastes:
    BorderOffset% = 8

    ' Define the four corners of the 3D box to draw:
    X1 = TargetControl.Left - BorderOffset%
    Y1 = TargetControl.Top - BorderOffset%
    X2 = X1 + TargetControl.Width + (BorderOffset% * 2)
    Y2 = Y1 + TargetControl.Height + (BorderOffset% * 2)

    ' We'll change the parent form's ForeColor and DrawWidth
    ' properties, so we'll save them first and restore when done
    OriginalForeColor = TargetControl.Parent.ForeColor
    OriginalDrawWidth = TargetControl.Parent.DrawWidth

    ' If RaisedBorder% is True, the white lines are drawn
    ' on the top and left sides; otherwise, they are drawn
    ' on the bottom and right sides.
    If RaisedBorder% Then
        UpperColor = QBColor(15)    ' white
        LowerColor = QBColor(8)     ' grey
    Else
        UpperColor = QBColor(8)     ' grey
        LowerColor = QBColor(15)    ' white
    End If
    ' Draw line on left
    TargetControl.Parent.DrawWidth = BorderWidth
    TargetControl.Parent.ForeColor = UpperColor
    TargetControl.Parent.Line (X1, Y2)-(X1, Y1)
    ' Draw line on top
    TargetControl.Parent.Line -(X2, Y1)
    ' Draw line on right
    TargetControl.Parent.ForeColor = LowerColor
    TargetControl.Parent.Line -(X2, Y2)
    ' Draw line on bottom
    TargetControl.Parent.Line -(X1, Y2)
    ' Restore the parent form's original properties
    TargetControl.Parent.ForeColor = OriginalForeColor
    TargetControl.Parent.DrawWidth = OriginalDrawWidth


End Sub

Sub PlaySound (SoundFile$)
    wFlags% = SND_ASYNC  ' Play asynchronously (returns immediately)
    x% = SndPlaySound(SoundFile$, wFlags%)
End Sub

Sub ShowResources ()
     VBITS1.Print "Free Memory:"; GetFreeSpace(0),
     VBITS1.Print "GDI:"; GetFreeSystemResources(GFSR_GDIResources%); "%",
     VBITS1.Print "User:"; GetFreeSystemResources(GFSR_UserResources%); "%"
End Sub

