VERSION 2.00
Begin Form frmFindXL 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "FindXL"
   ClientHeight    =   1080
   ClientLeft      =   1080
   ClientTop       =   1485
   ClientWidth     =   3615
   Height          =   1485
   Icon            =   FINDXL.FRX:0000
   Left            =   1020
   LinkTopic       =   "frmGOCO"
   MaxButton       =   0   'False
   ScaleHeight     =   1080
   ScaleWidth      =   3615
   Top             =   1140
   Width           =   3735
   Begin CommandButton cmdAbout 
      Caption         =   "About"
      Height          =   285
      Left            =   2430
      TabIndex        =   3
      Top             =   720
      Width           =   1095
   End
   Begin CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Close"
      Height          =   285
      Left            =   1260
      TabIndex        =   1
      Top             =   720
      Width           =   1095
   End
   Begin CommandButton cmdDoIt 
      Caption         =   "Find"
      Default         =   -1  'True
      Height          =   285
      Left            =   90
      TabIndex        =   0
      Top             =   720
      Width           =   1095
   End
   Begin Label labAbout 
      Caption         =   "FindXL is a debug tool to aid in developing and testing applications using Visual Basic 3.0 and the OLE Automation objects in Microsoft Excel. When Visual Basic 3.0 ends without closing a hidden copy of Microsoft Excel, for example in the event of a run-time error, the hidden copy cannot be found and terminated with Task Manager. Furthermore, you may wish to examine the state of the hidden instance. This applet allows you to do so relatively easily."
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   8.25
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   2265
      Left            =   90
      TabIndex        =   4
      Top             =   1080
      Width           =   3435
   End
   Begin Label labInfo 
      Caption         =   "Use OLE Automation to find hidden instances of Microsoft Excel and make them visible."
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   8.25
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   555
      Left            =   90
      TabIndex        =   2
      Top             =   90
      Width           =   3435
   End
End
Option Explicit

Dim miOriginalHeight As Integer

' MsgBox parameters
Const MB_OK = 0                 ' OK button only
Const MB_YESNO = 4              ' Yes and No buttons
Const MB_ICONQUESTION = 32      ' Warning query
Const MB_ICONEXCLAMATION = 48   ' Warning message
Const MB_ICONINFORMATION = 64   ' Information message

' MsgBox return values
Const IDOK = 1                  ' OK button pressed
Const IDCANCEL = 2              ' Cancel button pressed
Const IDYES = 6                 ' Yes button pressed
Const IDNO = 7                  ' No button pressed

Sub cmdAbout_Click ()

    If cmdAbout.Caption = "About" Then
        miOriginalHeight = frmFindXL.Height
        frmFindXL.Height = frmFindXL.Height + labAbout.Height
        cmdAbout.Caption = "OK"
        cmdDoIt.Enabled = False
        cmdCancel.Enabled = False
    Else
        frmFindXL.Height = miOriginalHeight
        cmdAbout.Caption = "About"
        cmdDoIt.Enabled = True
        cmdCancel.Enabled = True
    End If

End Sub

Sub cmdCancel_Click ()

    Unload Me

End Sub

Sub cmdDoIt_Click ()
    Dim objXL As object
    Dim strMsg As String

    ' Set error handling for GetObject call.
    '
    On Error GoTo NoExcel

    ' First, call GetObject() with no filename, and the ID of the
    ' Microsoft Excel Application object. If there are instances
    ' currently running, this returns the Application object
    ' of the most recently loaded instance.
    '
    Set objXL = GetObject(, "Excel.Application")

    ' Any errors from this point on just get displayed.
    '
    On Error GoTo BadOLE

    If objXL.visible = True Then
        strMsg = "An instance of Microsoft Excel was found, but "
        strMsg = strMsg & "it is already visible. If there are hidden "
        strMsg = strMsg & "instances, they were started before the visible "
        strMsg = strMsg & "instance. In order to find them, the visible "
        strMsg = strMsg & "instance must first be closed."
        MsgBox strMsg, MB_ICONINFORMATION, "FindXL"
    Else
        strMsg = "A hidden instance of Microsoft Excel was found. "
        strMsg = strMsg & "Do you want to make it visible?"
        If MsgBox(strMsg, MB_ICONQUESTION Or MB_YESNO, "FindXL") = IDYES Then
            objXL.visible = True
        End If
    End If
    Exit Sub

NoExcel:
    strMsg = "No application instances of Microsoft Excel were found."
    MsgBox strMsg, MB_ICONINFORMATION, "FindXL"
    Exit Sub

BadOLE:
    MsgBox Error, MB_ICONEXCLAMATION, "FindXL"
    Exit Sub
End Sub
